#include <cstdlib>
#include "MontyHall.h"

MontyHall::MontyHall()
:
state_(Initial)
,missIndex_(-1)
,selectedIndex_(-1)
{
	for (size_t i = 0; i < numOfPrize__; ++ i) {
		prize_[i] = false;
	}

	int hit = rand() % numOfPrize__;
	prize_[hit] = true;
}

bool
MontyHall::Select1st(int index)
{
	if (Initial != state_) {
		return false;
	}
	if (!isValidIndex(index)) {
		return false;
	}

	selectedIndex_ = index;

	for (size_t i = 0; i < numOfPrize__; ++ i) {
		if (!prize_[i] && index != i) {
			missIndex_ = i;
			break;
		}
	}

	state_ = FirstSelect;

	return true;
}

bool
MontyHall::GetMissIndex(
	int& missIndex
) const
{
	if (FirstSelect != state_) {
		return false;
	}
	if (!isValidIndex(missIndex_)) {
		return false;
	}

	missIndex = missIndex_;

	return true;
}

bool
MontyHall::Select2nd(int index)
{
	if (!isValidIndex(index)) {
		return false;
	}
	if (FirstSelect != state_) {
		return false;
	}
	selectedIndex_ = index;
	state_ = SecondSelect;

	return true;
}

bool MontyHall::Result(
	bool& result
) const
{
	if (!isValidIndex(selectedIndex_)) {
		return false;
	}
	if (state_ == Initial) {
		return false;
	}

	result = prize_[selectedIndex_];

	return true;
}

bool
MontyHall::isValidIndex(
	int index
)
{
	if (index < 0 || numOfPrize__ <= index) {
		return false;
	}

	return true;
}
