#ifndef __MONTY_HALL_H__
#define __MONTY_HALL_H__

class MontyHall {
public:
	const static size_t numOfPrize__ = 3;
private:
	enum State {
		Initial,
		FirstSelect,
		SecondSelect
	};
private:
	bool prize_[numOfPrize__];
	State state_;
	int missIndex_;
	int selectedIndex_;
public:
	MontyHall();
	bool Select1st(int index);
	bool GetMissIndex(int& missIndex) const;
	bool Select2nd(int index);
	bool Result(bool& result) const;
private:
	static bool isValidIndex(int index);
private:
	MontyHall& operator=(const MontyHall& rhs);
	MontyHall(const MontyHall&);
};

#endif /* __MONTY_HALL_H__ */
