#include <cstdio>
#include <cstdlib>
#include "MontyHall.h"

const static int numOfTry = 100000;

int
main(
	int argc,
	char* argv[]
)
{
	int hit = 0, miss = 0;

	srand(1000);
	for (int i = 0; i < numOfTry; ++ i) {
		MontyHall montyHall;
		montyHall.Select1st(rand() % MontyHall::numOfPrize__);
		bool result = false;
		if (!montyHall.Result(result)) {
			fprintf(stderr, "An error occured.");
			break;
		}
		if (result) {
			++ hit;
		}
		else {
			++ miss;
		}
	}
	fprintf(stdout, "[Monty Hall w/o selection changing] hit: %d, miss: %d.\n", hit, miss);

	srand(1000);
	hit = miss = 0;
	for (int i = 0; i < numOfTry; ++ i) {
		MontyHall montyHall;
		int firstSelect = rand() % MontyHall::numOfPrize__;
		montyHall.Select1st(firstSelect);

		bool result = false;
		int missIndex = -1;
		if (!montyHall.GetMissIndex(missIndex)) {
			fprintf(stderr, "An error occured.");
			break;
		}
		int secondSelect = -1;
		for (int i = 0; i < MontyHall::numOfPrize__; ++ i) {
			if (firstSelect != i && missIndex != i) {
				secondSelect = i;
			}
		}
		if (-1 == secondSelect) {
			fprintf(stderr, "An error occured.");
			break;
		}
		if (!montyHall.Select2nd(secondSelect)) {
			fprintf(stderr, "An error occured.");
			break;
		}
		if (!montyHall.Result(result)) {
			fprintf(stderr, "An error occured.");
			break;
		}
		if (result) {
			++ hit;
		}
		else {
			++ miss;
		}
	}
	fprintf(stdout, "[Monty Hall w/ selection changing] hit: %d, miss: %d.\n", hit, miss);

	return 0;
}
